#include "notes.h"

#include "FastLED.h"
#define NUM_LEDS 8
#define DATA_PIN 5
#define CLOCK_PIN 6
CRGB leds[NUM_LEDS];

#include <Audio.h>
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
#include <SerialFlash.h>


// GUItool: begin automatically generated code
AudioInputI2S            i2s1;           //xy=126,298
AudioSynthWaveformSineModulated sine_fm1;       //xy=140,102
AudioEffectMultiply      multiply1;      //xy=184,179
AudioMixer4              mixer3;         //xy=301,244
AudioEffectDelay         delay1;         //xy=368,486
AudioMixer4              mixer1;         //xy=371,343
AudioMixer4              mixer2;         //xy=381,121
AudioAnalyzePeak         peak2;          //xy=584,115
AudioAnalyzePeak         peak1;          //xy=633,333
AudioOutputI2S           i2s2;           //xy=719,229
AudioConnection          patchCord1(i2s1, 0, mixer3, 0);
AudioConnection          patchCord2(i2s1, 1, mixer1, 0);
AudioConnection          patchCord3(sine_fm1, 0, multiply1, 0);
AudioConnection          patchCord4(multiply1, 0, mixer2, 0);
AudioConnection          patchCord5(mixer3, 0, multiply1, 1);
AudioConnection          patchCord6(delay1, 0, mixer1, 1);
AudioConnection          patchCord7(mixer1, delay1);
AudioConnection          patchCord8(mixer1, 0, i2s2, 1);
AudioConnection          patchCord9(mixer1, peak1);
AudioConnection          patchCord10(mixer2, 0, i2s2, 0);
AudioConnection          patchCord11(mixer2, peak2);
AudioControlSGTL5000     sgtl5000_1;     //xy=590,44
// GUItool: end automatically generated code






long prevM1 = 0;
long prevM2 = 0;
long prevM3 = 0;
long prevM4 = 0;

int button1pin = 2;
int prevbutton1;
int button1;
int freq1;
int freq2;
int touch1;
int prevtouch1;
int threshold1 = 1050;
int touch1level;
int rate1;
int seq_step1;
int seq_step2;

int seq_trig;
long env_timer;
int env_trig;
float freq_out1;
float freq_out2;
int seq_tick1;
float seq1[8] = {note_c5, note_a5, note_d5, note_b5, note_g4, note_b4, note_b5, note_d5};

float mod_amp;
float mod_freq = 1;


void setup()
{

  AudioNoInterrupts(); // turns off audio processing untill we're done setting up.

  Serial.begin(9600);

  FastLED.addLeds<APA102, DATA_PIN, CLOCK_PIN, RGB, DATA_RATE_KHZ(100)>(leds, NUM_LEDS);

  pinMode(button1pin, INPUT_PULLUP);

  sgtl5000_1.enable();  //this sets up the audio shield
  sgtl5000_1.volume(0.5); //headphone vilume level. 0.75 is as high as you can go before clipping is the sigal getting sent to it is "1"

  AudioMemory(75);  //alocates the % of RAM availale to the audio library. We need a bit due to the

  sine_fm1.amplitude(1);

  delay1.delay(0, 100);

  sgtl5000_1.unmuteLineout();
  sgtl5000_1.unmuteHeadphone();

  sgtl5000_1.inputSelect(AUDIO_INPUT_LINEIN );  //we'll be using the line in header instead of the microphone input

  sgtl5000_1.lineInLevel(29, 29); //lower the level for more gain. See the design tool for more info http://www.pjrc.com/teensy/gui/?info=AudioControlSGTL5000


  AudioInterrupts(); // turns audio back on
}



void loop()
{
  prevbutton1 = button1;
  button1 = digitalRead(button1pin);

  if ( button1 == 0 ) {
    // if the button pin is low, play the audio coming in the right channel through the delay and out the right channel

    mixer2.gain(0, 0);

    mixer1.gain(0, .7);
    mixer1.gain(1, .5);

    mixer3.gain(0, 0);


  }

  if ( button1 == 1) {
    // if the button pin is high, use the audio coming in the left channel is am modualted with the sine wave

    mixer2.gain(0, 1);

    mixer1.gain(0, 0);
    mixer1.gain(1, .5);  // you'll still hear the delay for a second after you change

    mixer3.gain(0, 1); //depth of modualtion

    freq_out1 = analogRead(A3) * 2;
    sine_fm1.frequency(freq_out1);

  }




  /////////////

  if (millis() - prevM3 > 30) { //update the led strip
    prevM3 = millis();
    float p1 = peak1.read() * 64 ;
    float p2 = peak2.read() * 64;
    for (int j = 0; j < NUM_LEDS; j ++ ) {
      leds[j].setRGB( 10, p1 ,  p2);
      //note it's RGB, not HSV like we've been using. green will blink with audio in, blue for fm sine
    }


    FastLED.show();

  }

  ///////////////



  if (millis() - prevM1 > 200) {
    prevM1 = millis();

    Serial.print("freq_out1 = ");
    Serial.println(freq_out1);

    Serial.print("button1 = ");
    Serial.println(button1);

    Serial.println();

  }


}
